routes/web.php
<?php

use App\Http\Controllers\Admin;
use App\Http\Controllers\CartController;
use App\Http\Controllers\DishController;
use Illuminate\Support\Facades\Auth;
use App\Http\Controllers\CafeController;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', [CafeController::class, 'index']);

Route::resource('cafes', CafeController::class)
    ->only(['index', 'show']);
Route::resource('dishes', DishController::class)
    ->only(['index', 'show']);
Route::post('cart/{dish}', [CartController::class, 'add'])
    ->name('cart.add');
Route::delete('cart/{dish}', [CartController::class, 'remove'])
    ->name('cart.remove');

Auth::routes();

Route::prefix('admin')->name('admin.')
    ->middleware(['auth', 'is_admin'])->group( function () {
    Route::resources([
        'dishes' => Admin\DishesController::class,
        'cafes' => Admin\CafesController::class,
        'users' => Admin\UserController::class
    ]);
});

app/Models/Dish.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsTo;
use Illuminate\Database\Eloquent\Relations\HasMany;

/**
 * @method static paginate(int $int)
 */
class Dish extends Model
{
    use HasFactory;

    protected $fillable = ['name', 'description', 'price', 'image', 'cafe_id'];

    public function cafe(): BelongsTo
    {
        return $this->belongsTo(Cafe::class);
    }

    public function orders(): HasMany
    {
        return $this->hasMany(Order::class);
    }
}

app/Http/Controllers/Admin/DishesController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Http\Requests\DishRequest;
use App\Models\Cafe;
use App\Models\Dish;
use Illuminate\Contracts\Foundation\Application;
use Illuminate\Contracts\View\Factory;
use Illuminate\Contracts\View\View;
use Illuminate\Http\RedirectResponse;
use Illuminate\Support\Facades\Auth;

class DishesController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return Application|Factory|View
     */
    public function index(): View|Factory|Application
    {
        $dishes = Dish::all();
        return view('admin.dishes.index', compact('dishes'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return Application|Factory|View
     */
    public function create(): View|Factory|Application
    {
        $cafes = Cafe::all();
        return view('admin.dishes.create', compact('cafes'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param DishRequest $request
     * @return RedirectResponse
     */
    public function store(DishRequest $request): RedirectResponse
    {
        $data = $request->validated();
        if ($request->hasFile('image')) {
            $data['image'] = $request->file('image')->store('pictures/dishes', 'public');
        }
        Dish::create(array_merge($data, ['user_id' => Auth::id()]));
        return redirect()->route('admin.dishes.index')->with('message', 'Новое блюдо добалено!');
    }

    /**
     * Display the specified resource.
     *
     * @param Dish $dish
     * @return Application|Factory|View
     */
    public function show(Dish $dish): View|Factory|Application
    {
        return view('admin.dishes.show', compact('dish'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param Dish $dish
     * @return Application|Factory|View
     */
    public function edit(Dish $dish): View|Factory|Application
    {
        $cafes = Cafe::all();
        return view('admin.dishes.edit', compact('dish', 'cafes'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param DishRequest $request
     * @param Dish $dish
     * @return RedirectResponse
     */
    public function update(DishRequest $request, Dish $dish): RedirectResponse
    {
        $data = $request->validated();
        if ($request->hasFile('image')) {
            $file = $request->file('image');
            $path = $file->store('pictures/cafes', 'public');
            $data['image'] = $path;
        }
        $dish->update($data);
        return redirect()->route('admin.dishes.index', compact('dish'))->with('message', 'Блюдо обновлено!');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param Dish $dish
     * @return RedirectResponse
     */
    public function destroy(Dish $dish): RedirectResponse
    {
        $dish->delete();
        return redirect()->route('admin.dishes.index')->with('message', 'Блюдо успешно удалено!');
    }
}

app/Http/Controllers/DishController.php
<?php

namespace App\Http\Controllers;

use App\Models\Dish;
use Illuminate\Contracts\Foundation\Application;
use Illuminate\Contracts\View\Factory;
use Illuminate\Contracts\View\View;

class DishController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return Application|Factory|View
     */
    public function index(): View|Factory|Application
    {
        $dishes = Dish::paginate(12);
        return view('dishes.index', compact('dishes'));
    }

    /**
     * Display the specified resource.
     *
     * @param Dish $dish
     * @return Application|Factory|View
     */
    public function show(Dish $dish): View|Factory|Application
    {
        return view('dishes.show', compact('dish'));
    }
}

resources/views/admin/dishes/create.blade.php
@extends('layouts.app')
@section('content')

    @if ($errors->any())
        <div class="alert alert-danger">
            <ul>
                @foreach ($errors->all() as $error)
                    <li>{{ $error }}</li>
                @endforeach
            </ul>
        </div>
    @endif

    <div class="container mb-4">
        <h2>Блюда для гурманов</h2>
    </div>

    <form method="post" action="{{ route('admin.dishes.store') }}" enctype="multipart/form-data">
        @csrf
        <div class="form-group">
            <label for="title">Название блюда</label>
            <input type="text" class="form-control" id="name" name="name" value="">
            @error('name')
            <div class="alert alert-danger">{{$message}}</div>
            @enderror
        </div>

        <div class="form-group">
            <label for="description">Описание Блюда</label>
            <textarea rows="7" class="form-control" id="description" name="description"></textarea>
            @error('description')
            <div class="alert alert-danger">{{$message}}</div>
            @enderror
        </div>

        <div class="form-group my-4">
            <label for="cafe_id">Рестораны</label>
            <select name="cafe_id" class="custom-select">
                @foreach($cafes as $cafe)
                <option value="{{$cafe->id}}">{{$cafe->name}}</option>
                @endforeach
            </select>
        </div>

        <div class="form-group">
            <label for="price">Цена</label>
            <input class="form-control" id="price" name="price" value="">
            @error('cost')
            <div class="alert alert-danger">{{$message}}</div>
            @enderror
        </div>

        <div class="form-group my-4">
            <div class="custom-file">
                <label class="custom-file-label" for="customFile">Выбрать файл</label>
                <input type="file" class="custom-file-input form-control" id="customFile" name="image">
            </div>
            @error('image')
            <div class="alert alert-danger">{{$message}}</div>
            @enderror
        </div>

        <button type="submit" class="btn btn-primary">Принять</button>
    </form>
@endsection

resources/views/admin/dishes/edit.blade.php
@extends('layouts.app')
@section('content')

    @if ($errors->any())
        <div class="alert alert-danger">
            <ul>
                @foreach ($errors->all() as $error)
                    <li>{{ $error }}</li>
                @endforeach
            </ul>
        </div>
    @endif
    <div class="container mb-4">
        <h2>Блюда для Гурманов</h2>
    </div>

    <form class="mb-5" method="post" action="{{ route('admin.dishes.update', ['dish' => $dish]) }}" enctype="multipart/form-data">
        @method('put')
        @csrf
        <h1>Изменить блюдо</h1>
        <div class="form-group my-3">
            <label for="name">Название блюда</label>
            <input type="text" class="form-control" id="name" name="name" value="{{$dish->name}}">
        </div>

        <div class="form-group my-3">
            <label for="description">Описание блюда</label>
            <textarea rows="7" class="form-control" id="description" name="description" >{{$dish->description}}</textarea>
        </div>

        <div class="form-group my-4">
            <label for="cafe_id">Рестораны</label>
            <select name="cafe_id" class="custom-select">
                {{old('cafe_id')}}
                @foreach($cafes as $cafe)
                    <option value="{{$cafe->id}}">{{$cafe->name}}</option>
                @endforeach
            </select>
        </div>

        <div class="form-group my-3">
            <label for="price">Цена</label>
            <input class="form-control" id="price" name="price" value="{{$dish->price}}">
        </div>

        <img src="{{asset('/storage/' . $dish->image)}}" alt="{{$dish->image}}" style="width:300px;height:230px;">
        <br>
        <div class="form-group my-4">
            <div class="custom-file">
                <label class="custom-file-label" for="customFile">Choose file</label>
                <input type="file" class="custom-file-input form-control" id="customFile" name="image" value="{{old('image')}}">
            </div>
        </div>

        <button type="submit" class="btn btn-primary">Принять изменения</button>
    </form>
@endsection

resources/views/admin/dishes/index.blade.php
@extends('layouts.app')
@section('content')

    @include('admin.parties.index')

@endsection

resources/views/admin/dishes/show.blade.php
@extends('layouts.app')
@section('content')
    <div class="container mb-4">
        <h2>Описание блюда </h2>

    <div class="card " style="width: 18rem;">
        <div class="card-header">Детали блюда: {{$dish->name}}</div>
        <img class="card-img-top" src="{{asset('/storage/' . $dish->image)}}" alt="{{$dish->image}}">
        <div class="card-body">
            <h5 class="card-title">{{$dish->name}}</h5>
            <p class="card-text">
                    {{$dish->description}}
            </p>
        </div>
        <footer class="blockquote-footer mb-3">
            Цена: {{number_format($dish->price, 2)}}
        </footer>
    </div>

</div>
@endsection